diff -up gnome-netstatus-2.28.0/src/netstatus-iface.c.clean gnome-netstatus-2.28.0/src/netstatus-iface.c
--- gnome-netstatus-2.28.0/src/netstatus-iface.c.clean	2009-10-20 09:03:50.548097159 +0100
+++ gnome-netstatus-2.28.0/src/netstatus-iface.c	2009-10-20 09:02:30.415021784 +0100
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2003 Sun Microsystems, Inc.
+ * Copyright (C) 2003-2009 Sun Microsystems, Inc.
  * Copyright (C) 2004 Red Hat Inc.
  *
  * This program is free software; you can redistribute it and/or
@@ -47,6 +47,9 @@
 #include <errno.h>
 #include <unistd.h>
 #include <string.h>
+#include <signal.h>
+
+#include <libscf.h>
 
 #include "netstatus-sysdeps.h"
 #include "netstatus-enums.h"
@@ -55,6 +58,11 @@
 #define NETSTATUS_IFACE_POLLS_IN_ERROR   10   /* no. of polls in error before increasing delay */
 #define NETSTATUS_IFACE_ERROR_POLL_DELAY 5000 /* delay to use when in error state */
 
+#define NWAM_AUTOMATIC_SELECTION_STRING ("Automatic Selection")
+
+#define NETSTATUS_IFACE_RESTART_SCRIPT_TESTFLAGS (G_FILE_TEST_EXISTS | G_FILE_TEST_IS_SYMLINK | G_FILE_TEST_IS_EXECUTABLE)
+static const gchar * NETSTATUS_IFACE_RESTART_SCRIPT = "/usr/bin/ifrestart";
+
 enum
 {
   PROP_0,
@@ -63,23 +71,54 @@ enum
   PROP_STATS,
   PROP_WIRELESS,
   PROP_SIGNAL_STRENGTH,
+  PROP_ESSID,
+  PROP_BSSID,
+  PROP_BSS_MODE,
+  PROP_MODE,
+  PROP_CONNECTED,
+  PROP_SECURITY,
+  PROP_AUTH_MODE,
+  PROP_TRACK_ACTIVE_INTERFACE,
   PROP_ERROR
 };
 
+enum
+{
+  RESTART_STATE,
+  LAST_SIGNAL
+};
+
 struct _NetstatusIfacePrivate
 {
   char           *name;
 
   NetstatusState  state;
   NetstatusStats  stats;
-  int             signal_strength;
   GError         *error;
 
+  
+  gboolean        connected;
+  char           *essid;
+  char           *bssid;
+  char           *bss_mode;
+  char           *mode;
+  char           *security;
+  char           *auth_mode;
+  int             signal_strength;
+
   int             sockfd;
   guint           monitor_id;
 
   guint           error_polling : 1;
   guint           is_wireless : 1;
+  gchar          *active_interface;
+  gboolean        track_active_interface;
+  gchar          *restart_output;
+  GPid            restart_pid;
+  gint            restart_status;
+  GIOChannel     *restart_outioc;
+  GIOChannel     *restart_errioc;
+  guint           restart_cwsource;
 };
 
 static void     netstatus_iface_instance_init   (NetstatusIface      *iface,
@@ -97,10 +136,12 @@ static void     netstatus_iface_get_prop
 static gboolean netstatus_iface_monitor_timeout (NetstatusIface      *iface);
 static void     netstatus_iface_init_monitor    (NetstatusIface      *iface);
 
-
+static gboolean netstatus_iface_restart_collect_output (NetstatusIface *iface);
 
 static GObjectClass *parent_class;
 
+static guint netstatus_iface_signals[LAST_SIGNAL] = { 0 };
+
 GType
 netstatus_iface_get_type (void)
 {
@@ -128,14 +169,24 @@ netstatus_iface_get_type (void)
   return type;
 }
 
-
 static void
 netstatus_iface_instance_init (NetstatusIface      *iface,
 			       NetstatusIfaceClass *klass)
 {
+  GError *err = NULL;
+
   iface->priv = g_new0 (NetstatusIfacePrivate, 1);
   
   iface->priv->state = NETSTATUS_STATE_DISCONNECTED;
+
+  iface->priv->restart_status  = -1;    /* never restarted */
+  iface->priv->restart_output  = NULL;
+  iface->priv->restart_outioc  = NULL;
+  iface->priv->restart_errioc  = NULL;
+
+  iface->priv->track_active_interface = FALSE;
+
+  iface->priv->active_interface = NULL;
 }
 
 static void
@@ -183,6 +234,86 @@ netstatus_iface_class_init (NetstatusIfa
 							 G_PARAM_READABLE));
 
   g_object_class_install_property (gobject_class,
+				   PROP_TRACK_ACTIVE_INTERFACE,
+				   g_param_spec_boolean ("track_active_interface",
+							 /* SUN_BRANDING */
+							 _("Track Active Interface"),
+							 /* SUN_BRANDING */
+							 _("Whether to track the system's active interface"),
+							 FALSE,
+							G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_ESSID,
+				   g_param_spec_string ("essid",
+						     /* SUN_BRANDING */
+						     _("ESSID"),
+						     /* SUN_BRANDING */
+						     _("Wireless ESSID"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_BSSID,
+				   g_param_spec_string ("bssid",
+						     /* SUN_BRANDING */
+						     _("BSSID"),
+						     /* SUN_BRANDING */
+						     _("Wireless BSSID"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_BSS_MODE,
+				   g_param_spec_string ("bss_mode",
+						     /* SUN_BRANDING */
+						     _("BSS_MODE"),
+						     /* SUN_BRANDING */
+						     _("Wireless BSS_Mode"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_CONNECTED,
+				   g_param_spec_boolean ("connected",
+							 /* SUN_BRANDING */
+							 _("Wireless CONNECTED"),
+							 /* SUN_BRANDING */
+							 _("Whether the interface is connected"),
+							 FALSE,
+							 G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_MODE,
+				   g_param_spec_string ("mode",
+						     /* SUN_BRANDING */
+						     _("MODE"),
+						     /* SUN_BRANDING */
+						     _("Wireless MODE"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_SECURITY,
+				   g_param_spec_string ("security",
+						     /* SUN_BRANDING */
+						     _("SECURITY"),
+						     /* SUN_BRANDING */
+						     _("Wireless SECURITY"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
+				   PROP_AUTH_MODE,
+				   g_param_spec_string ("auth_mode",
+						     /* SUN_BRANDING */
+						     _("AUTH_MODE"),
+						     /* SUN_BRANDING */
+						     _("Wireless AUTH_MODE"),
+						     NULL,
+						     G_PARAM_READABLE));
+
+  g_object_class_install_property (gobject_class,
 				   PROP_SIGNAL_STRENGTH,
 				   g_param_spec_int ("signal-strength",
 						     _("Signal"),
@@ -199,6 +330,16 @@ netstatus_iface_class_init (NetstatusIfa
 						       _("The current error condition"),
 						       NETSTATUS_TYPE_G_ERROR,
 						       G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+
+  netstatus_iface_signals[RESTART_STATE] = g_signal_new (
+    NETSTATUS_IFACE_SIGNAL_RESTART_STATE, 
+    G_TYPE_FROM_CLASS (gobject_class),
+    G_SIGNAL_RUN_CLEANUP | G_SIGNAL_NO_RECURSE | G_SIGNAL_NO_HOOKS,
+    G_STRUCT_OFFSET (NetstatusIfaceClass, restart_complete),
+    NULL, /* accumulator */
+    NULL, /* accumulator data */
+    g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
+
 }
 
 static void
@@ -221,6 +362,29 @@ netstatus_iface_finalize (GObject *objec
   g_free (iface->priv->name);
   iface->priv->name = NULL;
 
+  g_free (iface->priv->essid);
+  iface->priv->essid = NULL;
+
+  g_free (iface->priv->bssid);
+  iface->priv->bssid = NULL;
+
+  g_free (iface->priv->bss_mode);
+  iface->priv->bss_mode = NULL;
+
+  g_free (iface->priv->mode);
+  iface->priv->mode = NULL;
+
+  g_free (iface->priv->security);
+  iface->priv->security = NULL;
+
+  g_free (iface->priv->auth_mode);
+  iface->priv->auth_mode = NULL;
+
+  netstatus_iface_restart_collect_output (iface);
+  if (iface->priv->restart_output != NULL)
+    g_free (iface->priv->restart_output);
+  iface->priv->restart_output = NULL;
+
   g_free (iface->priv);
   iface->priv = NULL;
 
@@ -240,6 +404,9 @@ netstatus_iface_set_property (GObject   
     case PROP_NAME:
       netstatus_iface_set_name (iface, g_value_get_string (value));
       break;
+    case PROP_TRACK_ACTIVE_INTERFACE:
+      netstatus_iface_set_track_active_interface(iface, g_value_get_boolean (value));
+      break;
     case PROP_ERROR:
       netstatus_iface_set_error (iface, g_value_get_boxed (value));
       break;
@@ -271,9 +438,33 @@ netstatus_iface_get_property (GObject   
     case PROP_WIRELESS:
       g_value_set_boolean (value, iface->priv->is_wireless);
       break;
+    case PROP_TRACK_ACTIVE_INTERFACE:
+      g_value_set_boolean (value, iface->priv->track_active_interface);
+      break;
+    case PROP_ESSID:
+      g_value_set_string (value, iface->priv->essid);
+      break;
     case PROP_SIGNAL_STRENGTH:
       g_value_set_int (value, iface->priv->signal_strength);
       break;
+    case PROP_BSSID:
+      g_value_set_string (value, iface->priv->bssid);
+      break;
+    case PROP_BSS_MODE:
+      g_value_set_string (value, iface->priv->bss_mode);
+      break;
+    case PROP_MODE:
+      g_value_set_string (value, iface->priv->mode);
+      break;
+    case PROP_CONNECTED:
+      g_value_set_boolean (value, iface->priv->connected);
+      break;
+    case PROP_SECURITY:
+      g_value_set_string (value, iface->priv->security);
+      break;
+    case PROP_AUTH_MODE:
+      g_value_set_string (value, iface->priv->auth_mode);
+      break;
     case PROP_ERROR:
       g_value_set_boxed (value, iface->priv->error);
     default:
@@ -349,6 +540,14 @@ netstatus_iface_get_is_wireless (Netstat
   return iface->priv->is_wireless;
 }
 
+gboolean
+netstatus_iface_get_is_connected (NetstatusIface *iface)
+{
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), FALSE);
+
+  return iface->priv->connected;
+}
+
 int
 netstatus_iface_get_signal_strength (NetstatusIface *iface)
 {
@@ -357,6 +556,116 @@ netstatus_iface_get_signal_strength (Net
   return iface->priv->signal_strength;
 }
 
+G_CONST_RETURN char *
+netstatus_iface_get_essid (NetstatusIface *iface)
+{
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+
+  return iface->priv->essid;
+}
+
+G_CONST_RETURN char *
+netstatus_iface_get_bssid (NetstatusIface *iface)
+{
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+
+  return iface->priv->bssid;
+}
+
+G_CONST_RETURN char *
+netstatus_iface_get_bss_mode (NetstatusIface *iface)
+{
+  const char*   bss_mode = NULL;
+
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), bss_mode );
+  
+  if ( iface->priv->bss_mode == NULL ) {
+      return( bss_mode );
+  }
+  
+  if ( strcmp( iface->priv->bss_mode, "bss") == 0 ) {
+      /* SUN_BRANDING */
+      bss_mode = _("Infrastructure");
+  }
+  else
+  if ( strcmp( iface->priv->bss_mode, "ibss") == 0 ) {
+      /* SUN_BRANDING */
+      bss_mode = _("Computer-to-Computer (Ad Hoc)");
+  }
+  else  if ( strcmp( iface->priv->bss_mode, "any") == 0 ) {
+      /* SUN_BRANDING */
+      bss_mode = _("Any");
+  }
+
+
+  return bss_mode; 
+}
+
+G_CONST_RETURN char *
+netstatus_iface_get_mode (NetstatusIface *iface)
+{
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+
+  return iface->priv->mode;
+}
+
+G_CONST_RETURN char *
+netstatus_iface_get_security (NetstatusIface *iface)
+{
+  const char*   security = NULL;
+
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+
+  if ( iface->priv->security == NULL ) {
+      return( security );
+  }
+
+  if ( strcmp( iface->priv->security, "none") == 0 ) {
+      /* SUN_BRANDING */
+      security = _("None");
+  }
+  else
+  if ( strcmp( iface->priv->security, "wep") == 0 ) {
+      security = "WEP";
+  }
+  else
+  if ( strcmp( iface->priv->security, "wpa") == 0 ) {
+      security = "WPA";
+  }
+  else {
+      security = iface->priv->security;
+  }
+
+  return security;
+}
+
+G_CONST_RETURN char *
+netstatus_iface_get_auth_mode (NetstatusIface *iface)
+{
+  const char*   auth_mode = NULL;
+
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+
+  if ( iface->priv->auth_mode == NULL ) {
+      return( auth_mode );
+  }
+
+  if ( strcmp( iface->priv->auth_mode, "open") == 0 ) {
+      /* SUN_BRANDING */
+      auth_mode = _("Open");
+  }
+  else
+  if ( strcmp( iface->priv->auth_mode, "shared") == 0 ) {
+      /* SUN_BRANDING */
+      auth_mode = _("Shared");
+  }
+  else {
+      auth_mode = iface->priv->auth_mode;
+  }
+
+  return auth_mode;
+}
+
 void
 netstatus_iface_set_error (NetstatusIface *iface,
 			   const GError   *error)
@@ -553,14 +862,57 @@ netstatus_iface_poll_state (NetstatusIfa
 
 static gboolean
 netstatus_iface_poll_wireless_details (NetstatusIface *iface,
-				       int            *signal_strength)
+				       int            *signal_strength,
+                       gboolean       *connected,
+                       char          **essid,
+                       char          **bssid,
+                       char          **bss_mode,
+                       char          **mode,
+                       char          **security,
+                       char          **auth_mode )
 {
   char     *error_message;
   gboolean  is_wireless;
+#if defined(__sun)
+  wifi_info_t*  wi = netstatus_sysdeps_read_iface_wireless_details (iface->priv->name);
+
+  if ( wi != NULL ) {
+    is_wireless = TRUE;
+    if ( signal_strength )
+      *signal_strength = wi->signal_strength;
+
+    if ( connected )
+      *connected = wi->connected;
 
+    if ( essid ) {
+      *essid = g_strdup( wi->essid );
+    }
+    if ( bssid ) {
+      *bssid = g_strdup( wi->bssid );
+    }
+    if ( bss_mode ) {
+      *bss_mode = g_strdup( wi->bss_mode );
+    }
+    if ( mode ) {
+      *mode = g_strdup( wi->mode );
+    }
+    if ( security ) {
+      *security = g_strdup( wi->security );
+    }
+    if ( auth_mode ) {
+      *auth_mode = g_strdup( wi->auth_mode );
+    }
+    netstatus_wifi_info_free(wi);
+  }
+  else {
+    is_wireless = FALSE;
+  }
+#else 
   error_message = netstatus_sysdeps_read_iface_wireless_details (iface->priv->name,
 								 &is_wireless,
-								 signal_strength);
+								 signal_strength,
+                                 essid,
+                                 max_essid_len );
 
   if (error_message)
     {
@@ -574,6 +926,7 @@ netstatus_iface_poll_wireless_details (N
 
   netstatus_iface_clear_error (iface, NETSTATUS_ERROR_WIRELESS_DETAILS);
 
+#endif
   return is_wireless;
 }
 
@@ -611,12 +964,21 @@ netstatus_iface_increase_poll_delay_in_e
     }
 }
 
+#define MAX_ESSID_LEN   128
+
 static gboolean
 netstatus_iface_monitor_timeout (NetstatusIface *iface)
 {
   NetstatusState state;
   int            signal_strength;
-  gboolean       is_wireless;
+  char          *essid = NULL;
+  char          *bssid = NULL;
+  char          *bss_mode = NULL;
+  gboolean       connected = FALSE;       
+  char          *mode = NULL;
+  char          *security = NULL;
+  char          *auth_mode = NULL;
+  gboolean       is_wireless = NULL;
  
   state = netstatus_iface_poll_state (iface);
 
@@ -627,19 +989,115 @@ netstatus_iface_monitor_timeout (Netstat
       g_object_notify (G_OBJECT (iface), "state");
     }
 
-  is_wireless = netstatus_iface_poll_wireless_details (iface, &signal_strength);
+  /* Look for another interface it tracking active i/f  */
+  netstatus_iface_find_active_interface (iface);
+
+  is_wireless = netstatus_iface_poll_wireless_details (iface, &signal_strength, &connected, &essid,
+                                                       &bssid, &bss_mode, &mode, &security, &auth_mode );
   if (iface->priv->is_wireless != is_wireless)
     {
       iface->priv->is_wireless = is_wireless;
       g_object_notify (G_OBJECT (iface), "wireless");
     }
 
-  if (iface->priv->signal_strength != signal_strength)
-    {
-      iface->priv->signal_strength = signal_strength;
-      g_object_notify (G_OBJECT (iface), "signal-strength");
+  if ( is_wireless ) {
+      if (iface->priv->connected != connected)
+        {
+          iface->priv->connected = connected;
+          g_object_notify (G_OBJECT (iface), "connected");
+        }
+
+    if (iface->priv->signal_strength != signal_strength)
+      {
+        iface->priv->signal_strength = signal_strength;
+        g_object_notify (G_OBJECT (iface), "signal-strength");
+      }
+
+    if (iface->priv->essid == NULL || 
+        ( essid != NULL && strcmp(iface->priv->essid, essid ) != 0 ) )
+      {
+        if ( iface->priv->essid != NULL )
+            g_free(iface->priv->essid);
+
+        iface->priv->essid = essid;
+
+        g_object_notify (G_OBJECT (iface), "essid");
+      }
+    else if ( essid ) {
+      g_free(essid);
     }
 
+    if (iface->priv->bssid == NULL || 
+        ( bssid != NULL && strcmp(iface->priv->bssid, bssid ) != 0 ) )
+      {
+        if ( iface->priv->bssid != NULL )
+            g_free(iface->priv->bssid);
+
+        iface->priv->bssid = bssid;
+
+        g_object_notify (G_OBJECT (iface), "bssid");
+      }
+    else if ( bssid ) {
+      g_free(bssid);
+    }
+
+    if (iface->priv->bss_mode == NULL || 
+        ( bss_mode != NULL && strcmp(iface->priv->bss_mode, bss_mode ) != 0 ) )
+      {
+        if ( iface->priv->bss_mode != NULL )
+            g_free(iface->priv->bss_mode);
+
+        iface->priv->bss_mode = bss_mode;
+
+        g_object_notify (G_OBJECT (iface), "bss_mode");
+      }
+    else if ( bss_mode ) {
+      g_free(bss_mode);
+    }
+
+    if (iface->priv->mode == NULL || 
+        ( mode != NULL && strcmp(iface->priv->mode, mode ) != 0 ) )
+      {
+        if ( iface->priv->mode != NULL )
+            g_free(iface->priv->mode);
+
+        iface->priv->mode = mode;
+
+        g_object_notify (G_OBJECT (iface), "mode");
+      }
+    else if ( mode ) {
+      g_free(mode);
+    }
+
+    if (iface->priv->security == NULL || 
+        ( security != NULL && strcmp(iface->priv->security, security ) != 0 ) )
+      {
+        if ( iface->priv->security != NULL )
+            g_free(iface->priv->security);
+
+        iface->priv->security = security;
+
+        g_object_notify (G_OBJECT (iface), "security");
+      }
+    else if ( security ) {
+      g_free(security);
+    }
+
+    if (iface->priv->auth_mode == NULL || 
+        ( auth_mode != NULL && strcmp(iface->priv->auth_mode, auth_mode ) != 0 ) )
+      {
+        if ( iface->priv->auth_mode != NULL )
+            g_free(iface->priv->auth_mode);
+
+        iface->priv->auth_mode = auth_mode;
+
+        g_object_notify (G_OBJECT (iface), "auth_mode");
+      }
+    else if ( auth_mode ) {
+      g_free(auth_mode);
+    }
+  }
+
   netstatus_iface_increase_poll_delay_in_error (iface);
   
   return TRUE;
@@ -653,12 +1111,20 @@ netstatus_iface_init_monitor (NetstatusI
   iface->priv->stats.in_bytes    = 0;
   iface->priv->stats.out_bytes   = 0;
   iface->priv->signal_strength   = 0;
+  iface->priv->essid  = NULL;
   iface->priv->is_wireless       = FALSE;
+  iface->priv->connected = FALSE;
+  iface->priv->bssid = NULL;
+  iface->priv->bss_mode = NULL;
+  iface->priv->mode = NULL;
+  iface->priv->security = NULL;
+  iface->priv->auth_mode = NULL;
 
   g_object_freeze_notify (G_OBJECT (iface));
   g_object_notify (G_OBJECT (iface), "state");
   g_object_notify (G_OBJECT (iface), "wireless");
   g_object_notify (G_OBJECT (iface), "signal-strength");
+  g_object_notify (G_OBJECT (iface), "essid");
   g_object_thaw_notify (G_OBJECT (iface));
 
   if (iface->priv->monitor_id)
@@ -1024,7 +1490,7 @@ netstatus_iface_get_hw_details (Netstatu
 				char           **hw_addr)
 				
 {
-#ifdef SIOCGIFHWADDR
+#if defined(SIOCGIFHWADDR) && !defined(sun)
   static struct HwType *hw_type = NULL;
   struct ifreq          if_req;
   int                   fd;
@@ -1192,6 +1658,7 @@ netstatus_list_interface_names (GError *
 
   struct ifconf *if_conf;
   GList         *interfaces;
+  GList         *point_to_points;
   GList         *loopbacks;
   char          *p;
   int            fd;
@@ -1214,11 +1681,13 @@ netstatus_list_interface_names (GError *
 
   interfaces = NULL;
   loopbacks  = NULL;
+  point_to_points = NULL;
 
   for (p = if_conf->ifc_buf; p < if_conf->ifc_buf + if_conf->ifc_len;)
     {
       struct ifreq *if_req = (struct ifreq *) p;
       gboolean      loopback = FALSE;
+      gboolean      p2p = FALSE;
 
       p += sizeof (if_req->ifr_name) + NETSTATUS_SA_LEN (&if_req->ifr_addr);
 
@@ -1233,16 +1702,21 @@ netstatus_list_interface_names (GError *
       else
 	{
 	  loopback = (if_req->ifr_flags & IFF_LOOPBACK);
+          p2p = (if_req->ifr_flags & IFF_POINTOPOINT);
 	}
 
-      if (!loopback)
-	interfaces = netstatus_list_insert_unique (interfaces,
+      if (loopback)
+	loopbacks  = netstatus_list_insert_unique (loopbacks,
+						   g_strdup (if_req->ifr_name));
+      else if (p2p)
+	point_to_points  = netstatus_list_insert_unique (point_to_points,
 						   g_strdup (if_req->ifr_name));
       else
-	loopbacks  = netstatus_list_insert_unique (loopbacks,
+	interfaces = netstatus_list_insert_unique (interfaces,
 						   g_strdup (if_req->ifr_name));
     }
 
+  interfaces = g_list_concat (interfaces, point_to_points );
   interfaces = g_list_concat (interfaces, loopbacks);
 
   g_free (if_conf->ifc_buf);
@@ -1256,3 +1730,323 @@ netstatus_list_interface_names (GError *
 
   return interfaces;
 }
+
+
+/*
+ * Returns TRUE if the ifrestart script is installed.
+ */
+gboolean
+netstatus_iface_restart_available (NetstatusIface *iface)
+{
+  g_return_val_if_fail ((iface != NULL), FALSE);
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), FALSE);
+
+  return g_file_test (
+    NETSTATUS_IFACE_RESTART_SCRIPT, NETSTATUS_IFACE_RESTART_SCRIPT_TESTFLAGS);
+}
+
+/*
+ * Returns TRUE if the restart in progress.
+ */
+gboolean
+netstatus_iface_restart_inprogress (NetstatusIface *iface)
+{
+  g_return_val_if_fail ((iface != NULL), FALSE);
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), FALSE);
+  g_return_val_if_fail ((iface->priv != NULL), 0);
+
+  return (iface->priv->restart_status == -2);
+}
+
+/*
+ * Sets the interface restart status and emmits the signal.
+ */
+static void 
+netstatus_iface_restart_set_status (
+  NetstatusIface *iface, gint status)
+{
+  g_return_if_fail (iface != NULL);
+  g_return_if_fail (NETSTATUS_IS_IFACE (iface));
+  g_return_if_fail (iface->priv != NULL);
+
+  /* Restart process exit status */
+  iface->priv->restart_status = status;
+
+  /* Emit restart complete signal */
+  g_signal_emit (iface, 
+    netstatus_iface_signals[RESTART_STATE], 0);
+}
+
+/*
+ * Collect output and release IOChannels.
+ * This method returns TRUE if the error output was empty.
+ */
+static gboolean
+netstatus_iface_restart_collect_output (NetstatusIface *iface)
+{
+  gchar *  outstr  = NULL;
+  gsize    outsize = 0;
+  gchar *  errstr  = NULL;
+  gsize    errsize = 0;
+  GError * error   = NULL;
+
+  g_return_val_if_fail ((iface != NULL), FALSE);
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), FALSE);
+  g_return_val_if_fail ((iface->priv != NULL), FALSE);
+
+  /* Release stdout channel */
+  if (iface->priv->restart_outioc != NULL)
+    {
+      g_io_channel_read_to_end (iface->priv->restart_outioc,
+        &outstr, &outsize, &error);
+      g_io_channel_shutdown (iface->priv->restart_outioc, FALSE, &error);
+      g_io_channel_unref (iface->priv->restart_outioc);
+      iface->priv->restart_outioc = NULL;
+    }
+  /* Release stderr channel */
+  if (iface->priv->restart_errioc != NULL)
+    {
+      g_io_channel_read_to_end (iface->priv->restart_errioc,
+        &errstr, &errsize, &error);
+      g_io_channel_shutdown (iface->priv->restart_errioc, FALSE, &error);
+      g_io_channel_unref (iface->priv->restart_errioc);
+      iface->priv->restart_errioc = NULL;
+    }
+  /* Release the last interface restart output */
+  if (iface->priv->restart_output != NULL)
+    g_free (iface->priv->restart_output);
+  iface->priv->restart_output == NULL;
+  /* New restart output */
+  if (errsize != 0)
+    {
+      iface->priv->restart_output = g_strdup (errstr);
+    }
+  else if (outsize != 0)
+    {
+      iface->priv->restart_output = g_strdup (outstr);
+    }
+  if (outstr != NULL)
+    g_free (outstr);
+  if (errstr != NULL)
+    g_free (errstr);
+
+  return (errsize == 0);
+}
+
+/*
+ * Interface restart completition routine.
+ */
+static void 
+netstatus_iface_restart_complete (
+  GPid pid, gint status, NetstatusIface *iface)
+{
+  g_return_if_fail (iface != NULL);
+  g_return_if_fail (NETSTATUS_IS_IFACE (iface));
+  g_return_if_fail (iface->priv != NULL);
+
+  iface->priv->restart_cwsource = 0;
+
+  /* Release the output and error IOChannels */
+  if (netstatus_iface_restart_collect_output (iface))
+    {
+      netstatus_iface_restart_set_status (iface, status);
+    }
+  else
+    {
+      netstatus_iface_restart_set_status (iface, (status == 0)? 9999: status);
+    }
+}
+
+/*
+ * Initiates the restart for current interface and returns pid of 
+ * the restart process. Returns 0 if the restart fails.
+ */
+GPid
+netstatus_iface_restart (NetstatusIface *iface)
+{
+  gchar *   argv[3];
+  gint      out_fd;
+  gint      err_fd;
+  gboolean  result;
+  GError *  error = NULL;
+
+  g_return_val_if_fail ((iface != NULL), 0);
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), 0);
+  g_return_val_if_fail ((iface->priv != NULL), 0);
+  g_return_val_if_fail ((netstatus_iface_restart_inprogress (iface) == FALSE), 0);
+  g_return_val_if_fail ((netstatus_iface_get_name (iface) != NULL), 0);
+
+  /* Release the last interface restart output */
+  iface->priv->restart_outioc  = NULL;
+  iface->priv->restart_errioc  = NULL;
+  if (iface->priv->restart_output != NULL)
+    g_free (iface->priv->restart_output);
+  iface->priv->restart_output  = NULL;
+  netstatus_iface_restart_set_status (iface, -2);    /* is restarting */
+  argv[0] = g_strdup (NETSTATUS_IFACE_RESTART_SCRIPT);
+  argv[1] = g_strdup (netstatus_iface_get_name (iface));
+  argv[2] = NULL;
+  result = g_spawn_async_with_pipes (
+    NULL, argv, NULL, G_SPAWN_DO_NOT_REAP_CHILD,
+    NULL, NULL, 
+    &(iface->priv->restart_pid), 
+    NULL, &(out_fd), &(err_fd), 
+    &error);
+  g_free (argv[1]);
+  g_free (argv[0]);
+  if (result == FALSE)
+    {
+      /* Clean up on unsuccessful spawn */
+      netstatus_iface_restart_complete (0, G_SPAWN_ERROR_FAILED, iface);
+      return 0;
+    }
+
+  iface->priv->restart_outioc = g_io_channel_unix_new (out_fd);
+  iface->priv->restart_errioc = g_io_channel_unix_new (err_fd);
+  /* Set up the completition routine */
+  iface->priv->restart_cwsource = g_child_watch_add (iface->priv->restart_pid,
+    (GChildWatchFunc)netstatus_iface_restart_complete, iface);
+
+  return iface->priv->restart_pid;
+}
+
+/*
+ * Returns the process exit status of the last interface restart.
+ */
+gint
+netstatus_iface_restart_get_status (NetstatusIface  *iface)
+{
+  g_return_val_if_fail ((iface != NULL), -1);
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), -1);
+  g_return_val_if_fail ((iface->priv != NULL), -1);
+
+  return iface->priv->restart_status;
+}
+
+/*
+ * Returns an output of the last interface restart. 
+ */
+G_CONST_RETURN gchar *
+netstatus_iface_restart_get_output (NetstatusIface *iface)
+{
+  g_return_val_if_fail ((iface != NULL), "");
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), "");
+  g_return_val_if_fail ((iface->priv != NULL), "");
+
+  return (iface->priv->restart_output)? iface->priv->restart_output: "";
+}
+
+/*
+ * Interrupts the restart
+ */
+void
+netstatus_iface_restart_interrupt (NetstatusIface *iface)
+{
+  g_return_if_fail (iface != NULL);
+  g_return_if_fail (NETSTATUS_IS_IFACE (iface));
+  g_return_if_fail (iface->priv != NULL);
+  g_return_if_fail (netstatus_iface_restart_inprogress (iface) == TRUE);
+
+  kill (iface->priv->restart_pid, SIGKILL);
+}
+
+gboolean
+netstatus_iface_get_track_active_interface (NetstatusIface  *iface)
+{
+  gboolean track_active = FALSE;
+
+  g_return_val_if_fail (iface != NULL, track_active );
+  g_return_val_if_fail (NETSTATUS_IS_IFACE (iface), track_active );
+  g_return_val_if_fail (iface->priv != NULL, track_active );
+
+  track_active = iface->priv->track_active_interface;
+
+  return( track_active );
+}
+
+void
+netstatus_iface_set_track_active_interface (NetstatusIface  *iface, gboolean track_active )
+{
+  g_return_if_fail (iface != NULL);
+  g_return_if_fail (NETSTATUS_IS_IFACE (iface));
+  g_return_if_fail (iface->priv != NULL);
+
+  if ( iface->priv->track_active_interface != track_active ) {
+      iface->priv->track_active_interface = track_active;
+
+      if ( track_active ) {
+          if ( iface->priv->active_interface != NULL && strlen(iface->priv->active_interface)> 0 ) {
+            netstatus_iface_set_name( iface, iface->priv->active_interface );
+          }
+          else {
+              netstatus_iface_find_active_interface(iface);
+          }
+      }
+
+      g_object_notify (G_OBJECT (iface), "track_active_interface");
+  }
+}
+
+static void
+netstatus_iface_find_active_interface (NetstatusIface  *iface )
+{
+  GError *error = NULL;
+  GList  *iface_names;
+  gchar  *iface_name = NULL;
+
+  g_return_if_fail (iface != NULL);
+  g_return_if_fail (NETSTATUS_IS_IFACE (iface));
+  g_return_if_fail (iface->priv != NULL);
+
+  if (!iface->priv->track_active_interface)
+      return;
+
+  iface_names = netstatus_list_interface_names (&error);
+
+  if (iface_names)
+    {
+      GList *l;
+      gulong in_packets, out_packets;
+      gulong in_bytes, out_bytes;
+      char *error_message;
+      /* 
+       * Find first non error interface.
+       */
+      for (l = iface_names; l; l = l->next) {
+        if ( l->data && strncmp(l->data, "lo", 2) &&
+            (error_message = netstatus_sysdeps_read_iface_statistics (l->data,
+             &in_packets, &out_packets, &in_bytes, &out_bytes)) == NULL ) {
+            gchar *old_name = iface->priv->name;
+
+            /* Temporarily set the name, but don't use set_name function
+             * since it would signal a notification which we don't want here.
+             */
+            iface->priv->name = l->data;
+            NetstatusState state = netstatus_iface_poll_state (iface);
+            iface->priv->name = old_name;
+
+            if ( state != NETSTATUS_STATE_DISCONNECTED &&
+                 state != NETSTATUS_STATE_ERROR ) {
+                /* Success !! make this the iface_name */
+                iface_name = l->data;
+                break;
+            }
+        } else if (error_message != NULL ) {
+            g_free (error_message);
+        }
+      }
+
+      for (l = iface_names; l; l = l->next) {
+        /* Only free non used names */
+        if (iface_name == NULL || strcmp(l->data, iface_name)) {
+          g_free (l->data);
+        }
+      }
+      g_list_free (iface_names);
+
+      if ( iface_name ) {
+          netstatus_iface_set_name( iface, iface_name );
+          g_free( iface_name );
+      }
+    }
+}

